#include <bits/stdc++.h>

#define int long long
#define pii pair<long long, long long>

using namespace std;

signed main() {
    cin.tie(0); ios_base::sync_with_stdio(0);
    
    cout << setprecision(10) << fixed;
    int n, m;
    cin >> n >> m;
    double r;
    cin >> r;
    vector<pii> dw(n + 1, {0, 0});
    vector<double> x(n + 1, 0);
    for (int i = 1; i <= n; i++) cin >> dw[i].first >> dw[i].second;
    sort(dw.begin(), dw.end());
    for (int i = 1; i <= n; i++) {
        x[i] = x[i - 1] * pow(1 - r, dw[i].first - dw[i - 1].first) + r * dw[i].second;
    }

    while (m--) {
        int q;
        cin >> q;
        int id = lower_bound(dw.begin(), dw.end(), make_pair(q, (int) INT_MAX)) - dw.begin();
        cout << x[id - 1] * pow(1 - r, q - dw[id - 1].first) << "\n";
    }
}